// All database related API calls

import { ResponseCallback, SchemaFromBackend, SchemaStatsFromBackend, WsFrontendCall, wsKeys, wsReturnKey, wsSubKeys } from 'ts-common';
import { Broker } from './broker';

export const wsSchemaRequest: WsFrontendCall<{ saveStateID: string }, wsReturnKey.schemaResult> = (params, callback) => {
  Broker.instance().sendMessage(
    {
      key: wsKeys.schema,
      subKey: wsSubKeys.get,
      body: {
        cached: false,
        saveStateID: params.saveStateID,
      },
    },
    callback,
  );
};
export const wsSchemaSubscription = (callback: ResponseCallback<wsReturnKey.schemaResult>) => {
  const id = Broker.instance().subscribe(callback, wsReturnKey.schemaResult);
  return () => {
    Broker.instance().unSubscribe(wsReturnKey.schemaResult, id);
  };
};

export const wsSchemaStatsRequest: WsFrontendCall<{ saveStateID: string }> = params => {
  Broker.instance().sendMessage({
    key: wsKeys.schema,
    subKey: wsSubKeys.getSchemaStats,
    body: {
      cached: false,
      saveStateID: params.saveStateID,
    },
  });
};

export const wsSchemaStatsSubscription = (callback: ResponseCallback<wsReturnKey.schemaStatsResult>) => {
  const id = Broker.instance().subscribe(callback, wsReturnKey.schemaStatsResult);
  return () => {
    Broker.instance().unSubscribe(wsReturnKey.schemaStatsResult, id);
  };
};
